# Enum Class MethodHandles.Lookup.ClassOption

java.lang.Object
java.lang.Enum<MethodHandles.Lookup.ClassOption>
java.lang.invoke.MethodHandles.Lookup.ClassOption

All Implemented Interfaces:
  `Serializable, Comparable<MethodHandles.Lookup.ClassOption>, Constable`

Enclosing class:
  `MethodHandles.Lookup`

public static enum MethodHandles.Lookup.ClassOption extends Enum<MethodHandles.Lookup.ClassOption>
The set of class options that specify whether a hidden class created by `Lookup::defineHiddenClass` method is dynamically added as a new member to the nest of a lookup class and/or whether a hidden class has a strong relationship with the class loader marked as its defining loader.

Since:
  15

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NESTMATE`
  Specifies that a hidden class be added to nest of a lookup class as a nestmate.
  `STRONG`
  Specifies that a hidden class has a strong relationship with the class loader marked as its defining loader, as a normal class or interface has with its own defining loader.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static MethodHandles.Lookup.ClassOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static MethodHandles.Lookup.ClassOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### NESTMATE

    public static final MethodHandles.Lookup.ClassOption NESTMATE
    Specifies that a hidden class be added to nest of a lookup class as a nestmate.

    A hidden nestmate class has access to the private members of all classes and interfaces in the same nest.

    See Also:
      - `Class.getNestHost()`

  - ### STRONG

    public static final MethodHandles.Lookup.ClassOption STRONG
    Specifies that a hidden class has a strong relationship with the class loader marked as its defining loader, as a normal class or interface has with its own defining loader. This means that the hidden class may be unloaded if and only if its defining loader is not reachable and thus may be reclaimed by a garbage collector (JLS 12.7).

    By default, a hidden class or interface may be unloaded even if the class loader that is marked as its defining loader is reachable.

    See Java Language Specification:
      12.7 Unloading of Classes and Interfaces

- ## Method Details

  - ### values

    public static MethodHandles.Lookup.ClassOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static MethodHandles.Lookup.ClassOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null